#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1 Black
#property indicator_color2 Black
#property indicator_color3 Black
#property indicator_color4 Black
#property indicator_color5 Black
#property indicator_color6 Black
#property indicator_color7 Black

extern int maxWeeks = 50;
extern bool weeklyNotDaily = true;
extern bool showPivotLines = TRUE;
extern bool showPivotLabels = TRUE;
extern bool showPivotIcons = FALSE;
extern int pivotThickness = 0;
extern int pivotFontSize = 8;
extern string pivotFont = "Impact";
extern color R3Color = Red;
extern color R2Color = Red;
extern color R1Color = Red;
extern color PColor = Blue;
extern color S1Color = Green;
extern color S2Color = Green;
extern color S3Color = Green;
double bufzgz140[];
double bufzgz144[];
double bufzgz148[];
double bufzgz152[];
double bufzgz156[];
double bufzgz160[];
double bufzgz164[];
double PLevel;
double R1Level;
double R2Level;
double R3Level;
double S1Level;
double S2Level;
double S3Level;
int giz256 = 0;
int gzdigitsz260;

int init() {
   string lsz0;
   int lzstylez8;
   Print("###########################################################################");
   Print("                              Questions? Email us at: info@fxinstructor.com");
   Print("                              http://www.fxinstructor.com");
   Print("                              2007, FX Instructor, LLC");
   Print("                              FXI Pivots v1.0.3 (2007-06-12)");
   Print("###########################################################################");
   gzdigitsz260 = MarketInfo(Symbol(), MODE_DIGITS);
   IndicatorDigits(gzdigitsz260);
   if (weeklyNotDaily) {
      lzstylez8 = 2;
      lsz0 = "Week";
      IndicatorShortName("FXI Weekly Pivots");
   } else {
      lzstylez8 = 0;
      lsz0 = "Day";
      IndicatorShortName("FXI Daily Pivots");
   }
   if (showPivotLines) {
      SetIndexBuffer(0, bufzgz148);
      SetIndexLabel(0, "R3 " + lsz0);
      SetIndexStyle(0, DRAW_LINE, lzstylez8, pivotThickness, R3Color);
      SetIndexArrow(0, 160);
      SetIndexBuffer(1, bufzgz144);
      SetIndexLabel(1, "R2 " + lsz0);
      SetIndexStyle(1, DRAW_LINE, lzstylez8, pivotThickness, R2Color);
      SetIndexArrow(1, 160);
      SetIndexBuffer(2, bufzgz140);
      SetIndexLabel(2, "R1 " + lsz0);
      SetIndexStyle(2, DRAW_LINE, lzstylez8, pivotThickness, R1Color);
      SetIndexArrow(2, 160);
      SetIndexBuffer(3, bufzgz152);
      SetIndexLabel(3, "P " + lsz0);
      SetIndexStyle(3, DRAW_LINE, lzstylez8, pivotThickness, PColor);
      SetIndexArrow(3, 160);
      SetIndexBuffer(4, bufzgz156);
      SetIndexLabel(4, "S1 " + lsz0);
      SetIndexStyle(4, DRAW_LINE, lzstylez8, pivotThickness, S1Color);
      SetIndexArrow(4, 160);
      SetIndexBuffer(5, bufzgz160);
      SetIndexLabel(5, "S2 " + lsz0);
      SetIndexStyle(5, DRAW_LINE, lzstylez8, pivotThickness, S2Color);
      SetIndexArrow(5, 160);
      SetIndexBuffer(6, bufzgz164);
      SetIndexLabel(6, "S3 " + lsz0);
      SetIndexStyle(6, DRAW_LINE, lzstylez8, pivotThickness, S3Color);
      SetIndexArrow(6, 160);
   }
   return (0);
}

int deinit() {
   int liz0;
   if (weeklyNotDaily) liz0 = maxWeeks;
   else liz0 = 5 * maxWeeks;
   for (int liz4 = 1; liz4 <= liz0; liz4++) clearBars(liz4);
   Print("###########################################################################");
   Print("                              Questions? Email us at: info@fxinstructor.com");
   Print("                              Please visit our website: http://www.fxinstructor.com");
   Print("                              Thank you for using FXI Pivots!");
   Print("###########################################################################");
   return (0);
}

int start() {
   int liz0;
//   int lzindzcountedz4 = IndicatorCounted();
   if (weeklyNotDaily) liz0 = maxWeeks;
   else liz0 = 5 * maxWeeks;
   for (int liz8 = liz0; liz8 > 0; liz8--) doPivots(liz8);
   return (0);
}

void doPivots(int bar) {
   int tf;
   int lzdatetimez8;
   if (weeklyNotDaily) tf = 10080;
   else {
      tf = 1440;
      lzdatetimez8 = iTime(NULL, tf, bar);
   }
   if (!(!weeklyNotDaily) || !(TimeDayOfWeek(lzdatetimez8) < 1 || TimeDayOfWeek(lzdatetimez8) > 5)) {
      getLevels(bar, tf);
      if (showPivotLabels) drawPivotLabels(bar, tf);
      if (showPivotIcons) drawPivotIcons(bar, tf);
   }
   if (showPivotLines) drawPivotLines(bar, tf);
}
void getLevels(int bar, int tf)
{
   double high  = iHigh(Symbol(), tf, bar);
   double low   = iLow(Symbol(), tf, bar);
   double close = iClose(Symbol(), tf, bar);
   PLevel = (high + low + close) / 3.0;
   S1Level = 2.0 * PLevel - high;
   R1Level = 2.0 * PLevel - low;
   S2Level = PLevel - (high - low);
   R2Level = PLevel + (high - low);
   S3Level = low - 2.0 * (high - PLevel);
   R3Level = high + 2.0 * (PLevel - low);
}

void drawPivotIcons(int bar, int tf) {
   string lsz12;
   int lzdatetimez8 = iTime(Symbol(), tf, bar - 1);
   if (weeklyNotDaily) lsz12 = "Week";
   else lsz12 = "Day";
   if (ObjectFind("R1 " + lsz12 + " Icon " + bar) == -1) {
      ObjectCreate("R1 " + lsz12 + " Icon " + bar, OBJ_ARROW, 0, lzdatetimez8, R1Level + Point * giz256);
      ObjectSet("R1 " + lsz12 + " Icon " + bar, OBJPROP_ARROWCODE, 140);
      ObjectSet("R1 " + lsz12 + " Icon " + bar, OBJPROP_WIDTH, pivotThickness + 1);
      ObjectSet("R1 " + lsz12 + " Icon " + bar, OBJPROP_COLOR, R1Color);
   } else {
      ObjectSet("R1 " + lsz12 + " Icon " + bar, OBJPROP_TIME1, lzdatetimez8);
      ObjectSet("R1 " + lsz12 + " Icon " + bar, OBJPROP_PRICE1, R1Level + Point * giz256);
   }
   if (ObjectFind("R2 " + lsz12 + " Icon " + bar) == -1) {
      ObjectCreate("R2 " + lsz12 + " Icon " + bar, OBJ_ARROW, 0, lzdatetimez8, R2Level + Point * giz256);
      ObjectSet("R2 " + lsz12 + " Icon " + bar, OBJPROP_ARROWCODE, 141);
      ObjectSet("R2 " + lsz12 + " Icon " + bar, OBJPROP_WIDTH, pivotThickness + 1);
      ObjectSet("R2 " + lsz12 + " Icon " + bar, OBJPROP_COLOR, R2Color);
   } else {
      ObjectSet("R2 " + lsz12 + " Icon " + bar, OBJPROP_TIME1, lzdatetimez8);
      ObjectSet("R2 " + lsz12 + " Icon " + bar, OBJPROP_PRICE1, R2Level + Point * giz256);
   }
   if (ObjectFind("R3 " + lsz12 + " Icon " + bar) == -1) {
      ObjectCreate("R3 " + lsz12 + " Icon " + bar, OBJ_ARROW, 0, lzdatetimez8, R3Level + Point * giz256);
      ObjectSet("R3 " + lsz12 + " Icon " + bar, OBJPROP_ARROWCODE, 142);
      ObjectSet("R3 " + lsz12 + " Icon " + bar, OBJPROP_WIDTH, pivotThickness + 1);
      ObjectSet("R3 " + lsz12 + " Icon " + bar, OBJPROP_COLOR, R3Color);
   } else {
      ObjectSet("R3 " + lsz12 + " Icon " + bar, OBJPROP_TIME1, lzdatetimez8);
      ObjectSet("R3 " + lsz12 + " Icon " + bar, OBJPROP_PRICE1, R3Level + Point * giz256);
   }
   if (ObjectFind("P " + lsz12 + " Icon " + bar) == -1) {
      ObjectCreate("P " + lsz12 + " Icon " + bar, OBJ_ARROW, 0, lzdatetimez8, PLevel + Point * giz256);
      ObjectSet("P " + lsz12 + " Icon " + bar, OBJPROP_ARROWCODE, 164);
      ObjectSet("P " + lsz12 + " Icon " + bar, OBJPROP_WIDTH, pivotThickness + 1);
      ObjectSet("P " + lsz12 + " Icon " + bar, OBJPROP_COLOR, PColor);
   } else {
      ObjectSet("P " + lsz12 + " Icon " + bar, OBJPROP_TIME1, lzdatetimez8);
      ObjectSet("P " + lsz12 + " Icon " + bar, OBJPROP_PRICE1, PLevel + Point * giz256);
   }
   if (ObjectFind("S1 " + lsz12 + " Icon " + bar) == -1) {
      ObjectCreate("S1 " + lsz12 + " Icon " + bar, OBJ_ARROW, 0, lzdatetimez8, S1Level + Point * giz256);
      ObjectSet("S1 " + lsz12 + " Icon " + bar, OBJPROP_ARROWCODE, 129);
      ObjectSet("S1 " + lsz12 + " Icon " + bar, OBJPROP_WIDTH, pivotThickness + 1);
      ObjectSet("S1 " + lsz12 + " Icon " + bar, OBJPROP_COLOR, S1Color);
   } else {
      ObjectSet("S1 " + lsz12 + " Icon " + bar, OBJPROP_TIME1, lzdatetimez8);
      ObjectSet("S1 " + lsz12 + " Icon " + bar, OBJPROP_PRICE1, S1Level + Point * giz256);
   }
   if (ObjectFind("S2 " + lsz12 + " Icon " + bar) == -1) {
      ObjectCreate("S2 " + lsz12 + " Icon " + bar, OBJ_ARROW, 0, lzdatetimez8, S2Level + Point * giz256);
      ObjectSet("S2 " + lsz12 + " Icon " + bar, OBJPROP_ARROWCODE, 130);
      ObjectSet("S2 " + lsz12 + " Icon " + bar, OBJPROP_WIDTH, pivotThickness + 1);
      ObjectSet("S2 " + lsz12 + " Icon " + bar, OBJPROP_COLOR, S2Color);
   } else {
      ObjectSet("S2 " + lsz12 + " Icon " + bar, OBJPROP_TIME1, lzdatetimez8);
      ObjectSet("S2 " + lsz12 + " Icon " + bar, OBJPROP_PRICE1, S2Level + Point * giz256);
   }
   if (ObjectFind("S3 " + lsz12 + " Icon " + bar) == -1) {
      ObjectCreate("S3 " + lsz12 + " Icon " + bar, OBJ_ARROW, 0, lzdatetimez8, S3Level + Point * giz256);
      ObjectSet("S3 " + lsz12 + " Icon " + bar, OBJPROP_ARROWCODE, 131);
      ObjectSet("S3 " + lsz12 + " Icon " + bar, OBJPROP_WIDTH, pivotThickness + 1);
      ObjectSet("S3 " + lsz12 + " Icon " + bar, OBJPROP_COLOR, S3Color);
      return;
   }
   ObjectSet("S3 " + lsz12 + " Icon " + bar, OBJPROP_TIME1, lzdatetimez8);
   ObjectSet("S3 " + lsz12 + " Icon " + bar, OBJPROP_PRICE1, S3Level + Point * giz256);
}

void drawPivotLines(int bar, int tf) {
   int lzshiftz8 = iBarShift(Symbol(), 0, iTime(Symbol(), tf, bar - 1));
   int lzshiftz12 = iBarShift(Symbol(), 0, iTime(Symbol(), tf, bar - 2));
   if (bar == 1) lzshiftz12 = 0;
   for (int liz16 = lzshiftz8; liz16 >= lzshiftz12; liz16--) {
      bufzgz152[liz16] = PLevel;
      bufzgz140[liz16] = R1Level;
      bufzgz144[liz16] = R2Level;
      bufzgz148[liz16] = R3Level;
      bufzgz156[liz16] = S1Level;
      bufzgz160[liz16] = S2Level;
      bufzgz164[liz16] = S3Level;
   }
}

void drawPivotLabels(int bar, int tf) {
   string lsz12;
   int lzdatetimez8 = iTime(Symbol(), tf, bar - 1);
   if (weeklyNotDaily) lsz12 = "Week";
   else lsz12 = "Day";
   if (ObjectFind("R1 " + lsz12 + " Label " + bar) == -1) {
      ObjectCreate("R1 " + lsz12 + " Label " + bar, OBJ_TEXT, 0, lzdatetimez8, R1Level + Point * giz256);
      ObjectSet("R1 " + lsz12 + " Label " + bar, OBJPROP_WIDTH, pivotThickness);
      ObjectSet("R1 " + lsz12 + " Label " + bar, OBJPROP_COLOR, R1Color);
   } else {
      ObjectSet("R1 " + lsz12 + " Label " + bar, OBJPROP_TIME1, lzdatetimez8);
      ObjectSet("R1 " + lsz12 + " Label " + bar, OBJPROP_PRICE1, R1Level + Point * giz256);
   }
   ObjectSetText("R1 " + lsz12 + " Label " + bar, "R1 " + lsz12 + ": " + DoubleToStr(R1Level, gzdigitsz260), pivotFontSize, pivotFont, R1Color);
   if (ObjectFind("R2 " + lsz12 + " Label " + bar) == -1) {
      ObjectCreate("R2 " + lsz12 + " Label " + bar, OBJ_TEXT, 0, lzdatetimez8, R2Level + Point * giz256);
      ObjectSet("R2 " + lsz12 + " Label " + bar, OBJPROP_WIDTH, pivotThickness);
      ObjectSet("R2 " + lsz12 + " Label " + bar, OBJPROP_COLOR, R2Color);
   } else {
      ObjectSet("R2 " + lsz12 + " Label " + bar, OBJPROP_TIME1, lzdatetimez8);
      ObjectSet("R2 " + lsz12 + " Label " + bar, OBJPROP_PRICE1, R2Level + Point * giz256);
   }
   ObjectSetText("R2 " + lsz12 + " Label " + bar, "R2 " + lsz12 + ": " + DoubleToStr(R2Level, gzdigitsz260), pivotFontSize, pivotFont, R2Color);
   if (ObjectFind("R3 " + lsz12 + " Label " + bar) == -1) {
      ObjectCreate("R3 " + lsz12 + " Label " + bar, OBJ_TEXT, 0, lzdatetimez8, R3Level + Point * giz256);
      ObjectSet("R3 " + lsz12 + " Label " + bar, OBJPROP_WIDTH, pivotThickness);
      ObjectSet("R3 " + lsz12 + " Label " + bar, OBJPROP_COLOR, R3Color);
   } else {
      ObjectSet("R3 " + lsz12 + " Label " + bar, OBJPROP_TIME1, lzdatetimez8);
      ObjectSet("R3 " + lsz12 + " Label " + bar, OBJPROP_PRICE1, R3Level + Point * giz256);
   }
   ObjectSetText("R3 " + lsz12 + " Label " + bar, "R3 " + lsz12 + ": " + DoubleToStr(R3Level, gzdigitsz260), pivotFontSize, pivotFont, R3Color);
   if (ObjectFind("P " + lsz12 + " Label " + bar) == -1) {
      ObjectCreate("P " + lsz12 + " Label " + bar, OBJ_TEXT, 0, lzdatetimez8, PLevel + Point * giz256);
      ObjectSet("P " + lsz12 + " Label " + bar, OBJPROP_WIDTH, pivotThickness);
      ObjectSet("P " + lsz12 + " Label " + bar, OBJPROP_COLOR, PColor);
   } else {
      ObjectSet("P " + lsz12 + " Label " + bar, OBJPROP_TIME1, lzdatetimez8);
      ObjectSet("P " + lsz12 + " Label " + bar, OBJPROP_PRICE1, PLevel + Point * giz256);
   }
   ObjectSetText("P " + lsz12 + " Label " + bar, "P " + lsz12 + ": " + DoubleToStr(PLevel, gzdigitsz260), pivotFontSize, pivotFont, PColor);
   if (ObjectFind("S1 " + lsz12 + " Label " + bar) == -1) {
      ObjectCreate("S1 " + lsz12 + " Label " + bar, OBJ_TEXT, 0, lzdatetimez8, S1Level + Point * giz256);
      ObjectSet("S1 " + lsz12 + " Label " + bar, OBJPROP_WIDTH, pivotThickness);
      ObjectSet("S1 " + lsz12 + " Label " + bar, OBJPROP_COLOR, S1Color);
   } else {
      ObjectSet("S1 " + lsz12 + " Label " + bar, OBJPROP_TIME1, lzdatetimez8);
      ObjectSet("S1 " + lsz12 + " Label " + bar, OBJPROP_PRICE1, S1Level + Point * giz256);
   }
   ObjectSetText("S1 " + lsz12 + " Label " + bar, "S1 " + lsz12 + ": " + DoubleToStr(S1Level, gzdigitsz260), pivotFontSize, pivotFont, S1Color);
   if (ObjectFind("S2 " + lsz12 + " Label " + bar) == -1) {
      ObjectCreate("S2 " + lsz12 + " Label " + bar, OBJ_TEXT, 0, lzdatetimez8, S2Level + Point * giz256);
      ObjectSet("S2 " + lsz12 + " Label " + bar, OBJPROP_WIDTH, pivotThickness);
      ObjectSet("S2 " + lsz12 + " Label " + bar, OBJPROP_COLOR, S2Color);
   } else {
      ObjectSet("S2 " + lsz12 + " Label " + bar, OBJPROP_TIME1, lzdatetimez8);
      ObjectSet("S2 " + lsz12 + " Label " + bar, OBJPROP_PRICE1, S2Level + Point * giz256);
   }
   ObjectSetText("S2 " + lsz12 + " Label " + bar, "S2 " + lsz12 + ": " + DoubleToStr(S2Level, gzdigitsz260), pivotFontSize, pivotFont, S2Color);
   if (ObjectFind("S3 " + lsz12 + " Label " + bar) == -1) {
      ObjectCreate("S3 " + lsz12 + " Label " + bar, OBJ_TEXT, 0, lzdatetimez8, S3Level + Point * giz256);
      ObjectSet("S3 " + lsz12 + " Label " + bar, OBJPROP_WIDTH, pivotThickness);
      ObjectSet("S3 " + lsz12 + " Label " + bar, OBJPROP_COLOR, S3Color);
   } else {
      ObjectSet("S3 " + lsz12 + " Label " + bar, OBJPROP_TIME1, lzdatetimez8);
      ObjectSet("S3 " + lsz12 + " Label " + bar, OBJPROP_PRICE1, S3Level + Point * giz256);
   }
   ObjectSetText("S3 " + lsz12 + " Label " + bar, "S3 " + lsz12 + ": " + DoubleToStr(S3Level, gzdigitsz260), pivotFontSize, pivotFont, S3Color);
}

void clearBars(int bar) {
   string lsz4;
   if (weeklyNotDaily) lsz4 = "Week";
   else lsz4 = "Day";
   if (showPivotIcons) {
      ObjectDelete("P " + lsz4 + " Icon " + bar);
      ObjectDelete("R1 " + lsz4 + " Icon " + bar);
      ObjectDelete("R2 " + lsz4 + " Icon " + bar);
      ObjectDelete("R3 " + lsz4 + " Icon " + bar);
      ObjectDelete("S1 " + lsz4 + " Icon " + bar);
      ObjectDelete("S2 " + lsz4 + " Icon " + bar);
      ObjectDelete("S3 " + lsz4 + " Icon " + bar);
   }
   if (showPivotLabels) {
      ObjectDelete("P " + lsz4 + " Label " + bar);
      ObjectDelete("R1 " + lsz4 + " Label " + bar);
      ObjectDelete("R2 " + lsz4 + " Label " + bar);
      ObjectDelete("R3 " + lsz4 + " Label " + bar);
      ObjectDelete("S1 " + lsz4 + " Label " + bar);
      ObjectDelete("S2 " + lsz4 + " Label " + bar);
      ObjectDelete("S3 " + lsz4 + " Label " + bar);
   }
}